const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const game_teams = sequelize.define(
    'game_teams',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

color_label: {
        type: DataTypes.TEXT,
      
      

      },

sort_order: {
        type: DataTypes.INTEGER,
      
      

      },

final_score: {
        type: DataTypes.INTEGER,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  game_teams.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















    db.game_teams.hasMany(db.game_team_assignments, {
      as: 'game_team_assignments_game_team',
      foreignKey: {
          name: 'game_teamId',
      },
      constraints: false,
    });



    db.game_teams.hasMany(db.game_player_stats, {
      as: 'game_player_stats_game_team',
      foreignKey: {
          name: 'game_teamId',
      },
      constraints: false,
    });









//end loop



    db.game_teams.belongsTo(db.games, {
      as: 'game',
      foreignKey: {
        name: 'gameId',
      },
      constraints: false,
    });

    db.game_teams.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.game_teams.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.game_teams.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return game_teams;
};


